package com.streambase.contrib.stats;

import java.util.List;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.DataType;
import com.streambase.sb.client.CustomFunctionResolver;

public class TimeSeries {
	
	public final static Integer FUTURE = new Integer(10); 

	/**
	 * @param TimeSeries 	A list representing the sample data	 
	 * @return A string representing the r-function call
	 */
	@CustomFunctionResolver("ConvertListCustomFunctionResolver")
	public static String ConvertList(List<?> TimeSeries) {
		String lis = TimeSeries.toString();
		String listPart = "c(".concat(lis.substring(1,lis.length()-1)).concat(")");
		return "data = ".concat(listPart);
	}
	
	/**
	 * @param AR 	A list representing the ar coefficient
	 * @param diff 	A list representing the diff coefficent
	 * @param MA 	A list representing the ma coefficient
	 * @return A string representing the r-function call
	 */
	public static String CreateOrder(Integer AR, Integer diff, Integer MA) {		
		String one = AR.toString().concat(",");
		String two = diff.toString().concat(",");
		String three = MA.toString().concat(")");
		return "c(".concat(one).concat(two).concat(three);
	}
	
	/** 
	 * @param part1 First part of the string
	 * @param part2	Second part of the string
	 * @return A string representing the r-function call
	 */
	public static String CreateArima(Integer AR, Integer diff, Integer MA) {
		String order = CreateOrder(AR,diff,MA);
		return "predict(arima(data,order=".concat(order).concat("),").concat(FUTURE.toString()).concat(")$pred");
	}
	
	public static CompleteDataType ConvertListCustomFunctionResolver(
			CompleteDataType TimeSeries) {
		CompleteDataType element = TimeSeries.getElementType();	
		if (element == null || element.getDataType() != DataType.DOUBLE) {return null;}
		return CompleteDataType.forString();
	}

}
